pragma solidity ^0.4.4;
import "Auction.sol";
import "VickreyAuction.sol";
import "DutchAuction.sol";
import "EnglishAuction.sol";

contract Auctions {

    mapping(uint256 => Auction) auctions;
    uint256 numAuctions;

    // This function is used for testing
    function testAuction(uint256 id) returns (uint256 aid){
      return numAuctions;
    }
    
    function beginDutchAuction(uint256 reservePrice, address judgeAddress, uint256 biddingTimePeriod, uint256 offerPriceDecrement) returns(uint256 auctionID) {
        auctionID = numAuctions++;
        auctions[auctionID] = new DutchAuction(reservePrice, judgeAddress, biddingTimePeriod, offerPriceDecrement);
        return auctionID;
    }

    function beginEnglishAuction(uint256 reservePrice, address judgeAddress, uint256 biddingTimePeriod, uint256 minBidIncrement) returns(uint256 auctionID) {
        auctionID = numAuctions++;
        auctions[auctionID] = new EnglishAuction(reservePrice, judgeAddress, biddingTimePeriod, minBidIncrement);
        return auctionID;
    }

    function beginVickreyAuction(uint256 reservePrice, address judgeAddress, uint256 commitTimePeriod, uint256 revealTimePeriod, uint256 bidDepositAmount) returns(uint256 auctionID) {
        auctionID = numAuctions++;
        auctions[auctionID] = new VickreyAuction(reservePrice, judgeAddress, commitTimePeriod, revealTimePeriod, bidDepositAmount);
        return auctionID;
    }

    // you bid directly to the contract
}
